using System;
using System.IO;
using System.Net;
using System.Text;

namespace PatientIdList
{
  class MainClass
  {
    public static void Main(string[] args)
    {
      string HOST = "localhost";
      string PORT = "8000";
      string USER = "ormaster";
      string PASSWD = "ormaster";
      string CONTENT_TYPE = "application/xml";

      string URL = "http://" + HOST + ":" + PORT + "/api01rv2/patientlst1v2?class=01";
      /*
       class :01 新規・更新対象
       class :02 新規対象

       1.開始日           Base_StartDate              (IMPLIED)
       2.終了日           Base_EndDate                (IMPLIED)
       3.テスト患者区分   Contain_TestPatient_Flag    (IMPLIED)

       REQUIRED : 必須   IMPLIED : 任意
      */

      string BODY = @"
<data>
	<patientlst1req type=""record"">
		<Base_StartDate type=""string"">2012-06-01</Base_StartDate>
		<Base_EndDate type=""string"">2012-06-30</Base_EndDate>
		<Contain_TestPatient_Flag type=""string"">1</Contain_TestPatient_Flag>
	</patientlst1req>
</data>
      ";

      byte[] BODY_byte = Encoding.UTF8.GetBytes(BODY);
      HttpWebRequest req = (HttpWebRequest) HttpWebRequest.Create(URL);

      req.Method = "POST";
      req.ContentType = CONTENT_TYPE;
      req.ContentLength = BODY_byte.Length;
      req.Credentials = new NetworkCredential(USER, PASSWD);

      Console.WriteLine(BODY);

      HttpWebResponse res = null;
      try
      {
        Stream reqstream = req.GetRequestStream();
        reqstream.Write(BODY_byte, 0, BODY_byte.Length);
        reqstream.Close();

        res = (HttpWebResponse) req.GetResponse();

        Console.WriteLine(res.ResponseUri);
        Console.WriteLine(res.StatusDescription);
      }
      catch(WebException wex)
      {
        if(wex.Status == WebExceptionStatus.ProtocolError)
        {
          HttpWebResponse err = (HttpWebResponse) wex.Response;

          int errcode = (int) err.StatusCode;

          Console.WriteLine(err.ResponseUri);
          Console.WriteLine("{0}:{1}", errcode, err.StatusDescription);

          err.Close();
        }
        else
        {
          Console.WriteLine(wex.Message);
        }
      }
      if(res != null)
      {
        Stream str = res.GetResponseStream();
        StreamReader strread = new StreamReader(str);

        Console.WriteLine(strread.ReadToEnd());

        strread.Close();
        str.Close();
        res.Close();
      }
    }
  }
}


